// Vertex-Shader

// Vertex-Eingaben
$rein float3 vertexPos;
$rein float3 vertexNormale;
$rein float4 vertexFarbe;

// Vertex-Ausgaben an den FragmentShader
$raus float4 fragPos;
$raus float4 fragWeltPos;
$raus float3 fragNormale;
$raus float4 fragFarbe;

// Globale Konstanten
uniform float4x4 WeltMatrix, SichtMatrix, ProjMatrix;

$main()
{
  float4 pos = float4( vertexPos, 1.0f);
  float4 weltpos = mul( WeltMatrix, pos);
  float4 kampos = mul( SichtMatrix, weltpos);
  fragPos = mul( ProjMatrix, kampos);
  fragWeltPos = float4( weltpos.xyz, kampos.z / 500.0f);

  float3 weltnorm = mul( (float3x3) WeltMatrix, vertexNormale);
  fragNormale = weltnorm;

  fragFarbe = vertexFarbe;
}